import { BinaryReader, BinaryWriter } from "@bufbuild/protobuf/wire";
export declare const protobufPackage = "topology.node";
export interface SubscribeCroRequest {
    croId: string;
}
export interface SubscribeCroResponse {
    /** can return error codes if different than 0 */
    returnCode: number;
}
export interface UnsubscribeCroRequest {
    croId: string;
}
export interface UnsubscribeCroResponse {
    /** can return error codes if different than 0 */
    returnCode: number;
}
export interface GetCroHashGraphRequest {
    croId: string;
}
export interface GetCroHashGraphResponse {
    /** linearized vertices hashes */
    verticesHashes: string[];
}
export declare const SubscribeCroRequest: {
    encode(message: SubscribeCroRequest, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): SubscribeCroRequest;
    fromJSON(object: any): SubscribeCroRequest;
    toJSON(message: SubscribeCroRequest): unknown;
    create<I extends Exact<DeepPartial<SubscribeCroRequest>, I>>(base?: I): SubscribeCroRequest;
    fromPartial<I extends Exact<DeepPartial<SubscribeCroRequest>, I>>(object: I): SubscribeCroRequest;
};
export declare const SubscribeCroResponse: {
    encode(message: SubscribeCroResponse, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): SubscribeCroResponse;
    fromJSON(object: any): SubscribeCroResponse;
    toJSON(message: SubscribeCroResponse): unknown;
    create<I extends Exact<DeepPartial<SubscribeCroResponse>, I>>(base?: I): SubscribeCroResponse;
    fromPartial<I extends Exact<DeepPartial<SubscribeCroResponse>, I>>(object: I): SubscribeCroResponse;
};
export declare const UnsubscribeCroRequest: {
    encode(message: UnsubscribeCroRequest, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): UnsubscribeCroRequest;
    fromJSON(object: any): UnsubscribeCroRequest;
    toJSON(message: UnsubscribeCroRequest): unknown;
    create<I extends Exact<DeepPartial<UnsubscribeCroRequest>, I>>(base?: I): UnsubscribeCroRequest;
    fromPartial<I extends Exact<DeepPartial<UnsubscribeCroRequest>, I>>(object: I): UnsubscribeCroRequest;
};
export declare const UnsubscribeCroResponse: {
    encode(message: UnsubscribeCroResponse, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): UnsubscribeCroResponse;
    fromJSON(object: any): UnsubscribeCroResponse;
    toJSON(message: UnsubscribeCroResponse): unknown;
    create<I extends Exact<DeepPartial<UnsubscribeCroResponse>, I>>(base?: I): UnsubscribeCroResponse;
    fromPartial<I extends Exact<DeepPartial<UnsubscribeCroResponse>, I>>(object: I): UnsubscribeCroResponse;
};
export declare const GetCroHashGraphRequest: {
    encode(message: GetCroHashGraphRequest, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): GetCroHashGraphRequest;
    fromJSON(object: any): GetCroHashGraphRequest;
    toJSON(message: GetCroHashGraphRequest): unknown;
    create<I extends Exact<DeepPartial<GetCroHashGraphRequest>, I>>(base?: I): GetCroHashGraphRequest;
    fromPartial<I extends Exact<DeepPartial<GetCroHashGraphRequest>, I>>(object: I): GetCroHashGraphRequest;
};
export declare const GetCroHashGraphResponse: {
    encode(message: GetCroHashGraphResponse, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): GetCroHashGraphResponse;
    fromJSON(object: any): GetCroHashGraphResponse;
    toJSON(message: GetCroHashGraphResponse): unknown;
    create<I extends Exact<DeepPartial<GetCroHashGraphResponse>, I>>(base?: I): GetCroHashGraphResponse;
    fromPartial<I extends Exact<DeepPartial<GetCroHashGraphResponse>, I>>(object: I): GetCroHashGraphResponse;
};
export interface TopologyRpc {
    subscribeCro(request: SubscribeCroRequest): Promise<SubscribeCroResponse>;
    unsubscribeCro(request: UnsubscribeCroRequest): Promise<UnsubscribeCroResponse>;
    getCroHashGraph(request: GetCroHashGraphRequest): Promise<GetCroHashGraphResponse>;
}
export declare const TopologyRpcServiceName = "topology.node.TopologyRpc";
export declare class TopologyRpcClientImpl implements TopologyRpc {
    private readonly rpc;
    private readonly service;
    constructor(rpc: Rpc, opts?: {
        service?: string;
    });
    subscribeCro(request: SubscribeCroRequest): Promise<SubscribeCroResponse>;
    unsubscribeCro(request: UnsubscribeCroRequest): Promise<UnsubscribeCroResponse>;
    getCroHashGraph(request: GetCroHashGraphRequest): Promise<GetCroHashGraphResponse>;
}
interface Rpc {
    request(service: string, method: string, data: Uint8Array): Promise<Uint8Array>;
}
type Builtin = Date | Function | Uint8Array | string | number | boolean | undefined;
export type DeepPartial<T> = T extends Builtin ? T : T extends globalThis.Array<infer U> ? globalThis.Array<DeepPartial<U>> : T extends ReadonlyArray<infer U> ? ReadonlyArray<DeepPartial<U>> : T extends {} ? {
    [K in keyof T]?: DeepPartial<T[K]>;
} : Partial<T>;
type KeysOfUnion<T> = T extends T ? keyof T : never;
export type Exact<P, I extends P> = P extends Builtin ? P : P & {
    [K in keyof P]: Exact<P[K], I[K]>;
} & {
    [K in Exclude<keyof I, KeysOfUnion<P>>]: never;
};
export {};
//# sourceMappingURL=rpc_pb.d.ts.map